C*********************************************************************
C
C     PROGRAM xzcont_pt
C
C     x-zʿ޺ץ(, )
C
C      1997/07/24 
C          2000/11/02 
C
C*********************************************************************
      program xzcont_pt
*-----------------------------------------------------
      implicit real*8 ( a-h, o-z )
*-----------------------------------------------------

#include "grid_size_M.f"

      parameter ( nbr3 = 3*((nx+6)*(nz+6)/16+1) )
      parameter ( nxp = 256, nzp= 102)
*-----------------------------------------------------
      integer ibr(nbr3)
*-----------------------------------------------------
      parameter ( day = 86400.0 )
      parameter ( hour = 3600.0 )
      parameter ( PI = 3.141592D0 ) 

      real*8
     \   zgrid ( -2:nzb ), temp0 ( -2:nzb ), tpot0 ( -2:nzb ),
     \   dens0 ( -2:nzb ), ppai0 ( -2:nzb ), pres0 ( -2:nzb ),
     \   rvap0 ( -2:nzb ), qvap0 ( -2:nzb )

      real*8
     \     tpot ( -2:nxb, -2:nzb )

      real*4
     \    z0p ( 0:nz ), p0p ( 0:nz ), d0p ( 0:nz ),
     \ temp0p ( 0:nz ), tpot0p ( 0:nz ), pai0p ( 0:nz ),
     \ rvap0p ( 0:nz ), qvap0p ( 0:nz )

      real*4 
     \      tpotp ( nxp+1, nzp+1 ),
     \      tpall ( nxp+1, nzp+1 ),
     \      tpave ( nzp+1 ),
     \      tpdev ( nxp+1, nzp+1 )

      character*2 mint
      character*2 lt
      character*2 date
      character*17 header

      character*100 dumy
      character CSGI*1

*-----------------------------------------------------
      open (11,file='exparam')
      read (11,*) irun
      read (11,*) time0, nloop1, nloop2, dtime, ntmoni, ntkubu, times
      read (11,*) ylat, als

      call FOPEN ( irun+1 )

      do iz = 1,9
         read(16,'(a100)') dumy
      end do

      do iz = -2, nzb
         read(16,*) ii, zgrid(iz), pres0(iz), dens0(iz), temp0(iz),
     \                     tpot0(iz), ppai0(iz), qvap0(iz), rvap0(iz)
      end do

      do iz = 0, nz
         z0p(iz)   = zgrid(iz)
         p0p(iz)   = pres0(iz)
         d0p(iz)   = dens0(iz)
         temp0p(iz)= temp0(iz)
         tpot0p(iz)= tpot0(iz)
         pai0p(iz) = ppai0(iz)
         rvap0p(iz)= rvap0(iz)
         qvap0p(iz)= qvap0(iz)
      end do

      write(6,*) 'data number = ', nloop1
      write(6,*) 'INPUT DATA BEGINING, END, & INTERVAL' 
      write(6,*) 'itb ite interval ?'
      read (*,*) itb, ite, interv
      write(6,*) 'SELECT TEMP. MODE (I)' 
      write(6,*) '1; RAW PTEMP 2; DEVIATION ?' 
      read (5,*) IDN

      call sgpwsn
      read(*,*) iws

      call gropn(-iws)
      call sldiv( 'T', 2, 6 )
      call swlset( 'LALT',  .TRUE. )
      call sglset( 'LFULL', .TRUE. )
      call sglset( 'LCORNER', .FALSE. )
      call udlset( 'LMSG', .FALSE. )
      call uzfact(0.6)
*
      do it = 1, ite

      read(34) time, ((tpot(ix,iz),ix=-2,nxb), iz=-2,nzb)

      write(0,*) 'reading time = ', time

      if ( it .ge. itb   .and.  it .le. ite ) then
         if ( mod( (it-itb), interv ) .eq. 0 ) then

            write(0,*) 'writing time = ', time

c*** Ѵ: ä LT ************************************
            time = time + times
            write(date,'(I2.2)') INT( time / day ) + 1

            time = ( time - INT( time / day ) * day ) / hour 

            if ( INT(time) .ge. 24 ) then
               time = time - 24
            end if

            write(lt, '(I2.2)') INT(time)
            write(mint, '(I2.2)') INT( MOD(time,1)*60.0 )

            header = 'day=' // date // ' ' // 'LT=' // lt // ':' // mint
c**************************************************************
c** 2-grid noize ν ***************************************

            do iz = 1,nzp+1            
               do ix = 1, nxp+1
                  tpotp(ix,iz) = ( tpot(2*(ix-1)-1,2*(iz-1)) +
     \        2.0*tpot(2*(ix-1),2*(iz-1)) + tpot(2*ix-1,2*(iz-1)))/4.0
                  tpall(ix,iz) = tpotp(ix,iz) + tpot0(2*(iz-1))
               end do
            end do

c**************************************************************

            do iz = 1, nzp+1
               tpave(iz) = 0.
               do ix = 1,nxp+1
                  tpave(iz) = tpave(iz) + tpall(ix,iz) /(nxp+1)
               end do
            end do

            do iz = 1,nzp+1
               do ix = 1, nxp+1
                  tpdev(ix,iz) = tpall(ix,iz) - tpave(iz) 
               end do
            end do

            call grfrm
            call grswnd ( 0.0, 51.2, 0.0, 20.0 )
            call grsvpt ( 0.15, 0.95, 0.1, 0.42 )
            call grstrn (1)
            call uspfit
            call grstrf
            call udpset ( 'rsizet', 0.01 )
            call udpset ( 'ICYCLE', 5 )

            if ( IDN .eq. 1 ) then 
         
C            call ussttl ( CSGI(135)//'[K]', 'X[km]', '', 'Z[km]' )
            call usdaxs
            call uxsttl ( 'T', ltime, 1. )
            call udgcla ( 180.0, 250.0, 2.5 )
            call udcntz ( tpall, nxp+1, nxp+1, nzp+1, ibr, nbr3)
            call udgcla ( 250.0, 300.0, 5.0 )
            call udcntz ( tpall, nxp+1, nxp+1, nzp+1, ibr, nbr3)
            call uxsttl ( 'T', header, 1. )

            else

C            call ussttl ( CSGI(131)
C     \           //CSGI(135)//'[K]', 'X[km]', '', 'Z[km]' )
            call uestlv ( -20., 0., 603)
            call uetone ( tpdev, nxp+1, nxp+1, nzp+1 )
            call ueitlv
            call usdaxs
            call uxsttl ( 'T', header, 1. )
            call udgcla ( -20., 20., 1. )
            call udcntz ( tpdev, nxp+1, nxp+1, nzp+1, ibr, nbr3)

            end if

         end if
      end if

      end do

      call grcls

      call FCLOSE

      end
